defmodule Nulla.KeysTest do
  use NullaWeb.ConnCase, async: false
  alias Nulla.KeyGen

  test "test KeyGen module" do
    message = "test message"
    {publicKeyPem, privateKeyPem} = KeyGen.gen()

    private_key =
      :public_key.pem_decode(privateKeyPem)
      |> hd()
      |> :public_key.pem_entry_decode()

    public_key =
      :public_key.pem_decode(publicKeyPem)
      |> hd()
      |> :public_key.pem_entry_decode()

    signature = :public_key.sign(message, :sha256, private_key)

    assert :public_key.verify(message, :sha256, signature, public_key)
  end
end
